--Set variables
local addOnName = ...

CAFilterPresets = {}

CAKeywordList = {}

CARestrictiveBoxBool = false;

local startPresetName = "None"

--CREATING FRAMES
--frame declarations
CAframe = CreateFrame("Frame", "CAMainFrame", UIParent)
CAscrollframe = CreateFrame("ScrollFrame", nil, CAframe)
CAscrollbar = CreateFrame("Slider", nil, CAscrollframe, "UIPanelScrollBarTemplate")
CAbuttonbar = CreateFrame("Frame", nil, CAscrollframe)
local content = CreateFrame("ScrollingMessageFrame", nil, CAscrollframe)
local FilterFrame = CreateFrame("Frame", nil, CAframe)
local CAFilterText = FilterFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge")
local CATitleText = FilterFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge")
local CAFilterKeywords = FilterFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
local filterDropdown = CreateFrame("Frame", "FilterDropdown", FilterFrame, "UIDropDownMenuTemplate")
local keywordFrame = CreateFrame("Frame", nil, FilterFrame)
local CARestrictiveBox = CreateFrame("CheckButton", "CARestrictiveBox_GlobalName", keywordFrame, "ChatConfigCheckButtonTemplate")
local keywordSelectFrame = CreateFrame("EditBox", "KeywordSelectBox", FilterFrame, "InputBoxTemplate")
local keywordPresetNameBox = CreateFrame("EditBox", "KeywordSelectBox", keywordSelectFrame, "InputBoxTemplate")
local CAdeletePresetButton = CreateFrame("Button", "DeletePresetButton", CAframe, "UIPanelButtonTemplate")
CAKeywordArrows = CreateFrame("Slider", nil, keywordSelectFrame, "UIPanelScrollBarTemplate")


local function AlignTextItems()
  CAframe:StopMovingOrSizing()
  content:SetSize(CAscrollframe:GetWidth(), CAscrollframe:GetHeight() + 200)
  CAscrollframe.ClearLogButton:SetPoint("BOTTOMLEFT", CAframe, (CAframe:GetWidth() / 2) - 100, 10)
  content:ClearAllPoints()
  content:SetJustifyH("LEFT") -- sets the horizontal text justification.
  content:SetPoint("TOPLEFT", CAscrollframe ,"TOPLEFT", 3.1, -3.3)
  content:SetPoint("BOTTOMRIGHT", CAscrollframe ,"BOTTOMRIGHT",-3.1, 3.3)

  CAscrollbar:SetValueStep(CAscrollbar.scrollStep)
end

--Search Term Helper FUNCTION
--Set the text to the keyword text
local function SetKeywordText()
  local keywordText = " "
  	for i = 1,table.getn(CAKeywordList),1 do
      if(i == table.getn(CAKeywordList)) then
      keywordText = keywordText .. " " .. tostring(CAKeywordList[i])
    else
      keywordText = keywordText .. " " .. tostring(CAKeywordList[i].. ",")
    end
    end
    keywordFrame.Text:SetText(keywordText)
    --set the delete selection arrow min/max values
    CAKeywordArrows:SetMinMaxValues(0, table.getn(CAKeywordList) + 1)
end

--clear the table of all the filter keywords
local function ClearKeywordText()
  for i = table.getn(CAKeywordList), 1, -1 do
    table.remove(CAKeywordList, i);
  end
  SetKeywordText()
end

--method for setting the custom filters
local function TestFunction(presetInfo, arg1, arg2, checked)
	-- show arguments in default chat
  if(not checked) then
  	UIDropDownMenu_SetSelectedValue(filterDropdown,  presetInfo.value);
    UIDropDownMenu_SetText(filterDropdown, "Preset: " .. presetInfo.value);

    ClearKeywordText()
    for i=1, table.getn(CAFilterPresets) do
      if(presetInfo.value == CAFilterPresets[i].name) then
        for j=1, table.getn(CAFilterPresets[i].filterwords)do
          table.insert(CAKeywordList, CAFilterPresets[i].filterwords[j])
        end

        if(CAKeywordList ~= nil) then
          SetKeywordText()
        else
          --do nothing *for now?*
        end
        break;
      end
    end

  end
end

local function SetFilterDropdownItems()
  UIDropDownMenu_Initialize(filterDropdown, function(self, level, menuList)
    --set initial button here
      for i=1, 1 do
        local presetInfo = UIDropDownMenu_CreateInfo()
        presetInfo.text = "None"
        presetInfo.value = "None"
        presetInfo.func = TestFunction;
        UIDropDownMenu_AddButton(presetInfo)
      end
      --set the other buttons that are within the filter presets table
      for i=1, table.getn(CAFilterPresets) do
        local presetInfo = UIDropDownMenu_CreateInfo()
        presetInfo.text = CAFilterPresets[i].name
        presetInfo.value = CAFilterPresets[i].name
        presetInfo.func = TestFunction;
        UIDropDownMenu_AddButton(presetInfo)
      end
  end)
end

--Main frame
CAframe:SetSize(460,380)
CAframe:SetPoint("CENTER")
CAframe:SetFrameStrata("BACKGROUND")
--these lines enable movement and resizing via mouse draggins
CAframe:SetMovable(true)
CAframe:EnableMouse(true)
CAframe:RegisterForDrag("LeftButton")
CAframe:SetUserPlaced(isUserPlaced)
CAframe:SetMinResize(360,280);
CAframe:SetClampedToScreen(true)
CAframe:SetResizable(true)
--allows the frame to be closed with the escape key
tinsert(UISpecialFrames, "CAMainFrame")
--allows the panel to be moved by the mouse
CAframe:SetScript("OnDragStart", CAframe.StartMoving)
CAframe:SetScript("OnMouseDown", function(self, button)
    if button == "LeftButton" and (IsShiftKeyDown()) and not CAframe.isMoving then
        self:StartSizing()
    end
end)
CAframe:SetScript("OnMouseUp", function(self, button)
    if button == "LeftButton" then
        AlignTextItems()
    end
end)
CAframe:SetScript("OnDragStop", CAframe.StopMovingOrSizing)
local texture = CAframe:CreateTexture()
--texture:SetAllPoints()
texture:SetPoint("TOPLEFT", CAframe ,"TOPLEFT", 2, -2)
texture:SetPoint("BOTTOMRIGHT", CAframe ,"BOTTOMRIGHT", -2, 2)
texture:SetColorTexture(.1,.1,.1,.8)
CAframe.background = texture
CAframe:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
CAframe:SetBackdropColor(.1, .1, .1, 1)
CAframe:SetBackdropBorderColor(1, 1, 1)

--scrollframe
CAscrollframe:SetPoint("TOPLEFT", 10, -40)
CAscrollframe:SetPoint("BOTTOMRIGHT", -10, 40)
local texture = CAscrollframe:CreateTexture()

CAscrollframe.background = texture
CAscrollframe:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
CAscrollframe:SetBackdropColor(.1, .1, .1, 1)
CAscrollframe:SetBackdropBorderColor(1, 1, 1)

CAframe.scrollframe = scrollframe
CAscrollframe:SetVerticalScroll(200)

--scrollbar
CAscrollbar:SetPoint("TOPLEFT", CAframe, "TOPRIGHT", 4, -16)
CAscrollbar:SetPoint("BOTTOMLEFT", CAframe, "BOTTOMRIGHT", 4, 16)
CAscrollbar:SetMinMaxValues(1, 200)
CAscrollbar:SetValueStep(1)
CAscrollbar.scrollStep = 200
CAscrollbar:SetValue(200)
CAscrollbar:SetWidth(16)
CAscrollbar:SetScript("OnValueChanged",
    function (self, value)
        CAscrollbar.scrollStep = value;
        self:GetParent():SetVerticalScroll(CAscrollbar.scrollStep)
    end)
local scrolltexture = CAscrollbar:CreateTexture(nil, "BACKGROUND")
scrolltexture:SetAllPoints(CAscrollbar)
scrolltexture:SetColorTexture(0, 0, 0, 0.4)
CAscrollbar.background = scrolltexture
CAframe.scrollbar = CAscrollbar

--buttonbar
CAbuttonbar:SetPoint("TOPRIGHT", CAframe, "TOPLEFT", -3, -80)
CAbuttonbar:SetPoint("BOTTOMRIGHT", CAframe, "BOTTOMLEFT", -3, 60)
CAbuttonbar:SetWidth(30)
CAframe.buttonbar = CAbuttonbar


--content frame
content:EnableMouse(true)
local texture = content:CreateTexture()
texture:SetAllPoints()

--texture:SetWidth(content:GetWidth())
--texture:SetHeight(content:GetHeight())
texture:SetPoint("TOPLEFT", CAscrollframe ,"TOPLEFT", 3.1, -3.3)
texture:SetPoint("BOTTOMRIGHT", CAscrollframe ,"BOTTOMRIGHT", -3.1, 3.3)
--some texture options
--texture:SetTexture("Interface\\LFGFrame\\UI-LFG-BACKGROUND-QUESTPAPER", true)
--texture:SetTexture("Interface\\Stationery\\StationeryTest1")
texture:SetTexture("Interface/QuestionFrame/question-background", true)
--texture:SetColorTexture(.5, .5, .5, .5)
content.texture = texture
content:SetSize(CAscrollframe:GetWidth(), CAscrollframe:GetHeight() + 200)
content:ClearAllPoints()
content:SetFontObject(GameFontNormal)
content:SetTextColor(1, 1, 1, 1) -- default color
content:SetJustifyH("LEFT")
content:SetFading(false)
content:SetMaxLines(300)
content:EnableMouse(true)
content:EnableMouseWheel(true)
content:SetHyperlinksEnabled(true)
content:SetPoint("TOPLEFT", CAscrollframe ,"TOPLEFT", 3.1, -3.3)
content:SetPoint("BOTTOMRIGHT", CAscrollframe ,"BOTTOMRIGHT",-3.1, 3.3)
content:SetScript("OnHyperlinkClick", function(self, link, text)
  local colonPos = strfind(link,":")
  local linkType = strsub(link, 0, colonPos - 1)
  --check if the linktype is that of a player, if so then open a direct message to them
  if(linkType == "player") then
    local playerNameCA = strsub(link, colonPos + 1)
    ChatFrame1EditBox:SetText("/w " .. playerNameCA .." ")
    ChatFrame1EditBox:Show()
    ChatFrame1EditBox:SetFocus()
  end
end)

CAscrollframe.content = content
CAscrollframe:SetScrollChild(content)

--clear chat log button
CAscrollframe.ClearLogButton = CreateFrame("Button", "ClearLog", CAframe, "UIPanelButtonTemplate")
CAscrollframe.ClearLogButton:SetText("Clear Chat Log")
CAscrollframe.ClearLogButton:SetPoint("BOTTOMLEFT", CAframe, (CAframe:GetWidth() / 2) - 100, 10)
CAscrollframe.ClearLogButton:SetWidth(175)
CAscrollframe.ClearLogButton:SetHeight(25)
CAscrollframe.ClearLogButton:SetNormalFontObject("GameFontNormal")
--Setting the background for the log clear button
CAscrollframe.ClearLogButton:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 16,
	insets = {left = 2, right = 2, top = 4.5, bottom = 4.5}});
CAscrollframe.ClearLogButton:SetBackdropColor(.75, 0, 0);
CAscrollframe.ClearLogButton:SetBackdropBorderColor(1, 1, 1)
CAscrollframe.ClearLogButton:SetScript("OnClick", function(self)
  content:Clear();
end)


--filterframe
FilterFrame:SetSize(150,380)
FilterFrame:SetPoint("TOPRIGHT",CAframe, "TOPRIGHT", 175, 0)
FilterFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
FilterFrame:SetBackdropColor(.1, .1, .1, 1)
FilterFrame:SetBackdropBorderColor(1, 1, 1)
CAframe.filterframe = FilterFrame

--Filter Text
CAFilterText:SetTextColor(1, 1, 0)
CAFilterText:SetPoint("TOP", FilterFrame, 0, -10)
CAFilterText:SetText("Filter Options")


--title text
CATitleText:SetTextColor(1, 1, 0)
CATitleText:SetPoint("TOP", CAframe, 0, -10)
CATitleText:SetText("Chat Assistant")

--filter keyword section text
CAFilterKeywords:SetTextColor(1, 1, 0)
CAFilterKeywords:SetPoint("Top", FilterFrame, 0, -40)
CAFilterKeywords:SetText("Filter Keywords")

--DROPDOWN FILTER LIST
filterDropdown:SetPoint("CENTER", CAFilterText, "CENTER",0, -255)
UIDropDownMenu_SetWidth(filterDropdown, 100)
UIDropDownMenu_SetText(filterDropdown, "Preset: " .. startPresetName)
UIDropDownMenu_JustifyText(filterDropdown, "LEFT")
SetFilterDropdownItems()

local CAPresetOptionsText = FilterFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
CAPresetOptionsText:SetTextColor(1, 1, 0)
CAPresetOptionsText:SetPoint("CENTER", FilterDropdown, "Center", 0, 25)
CAPresetOptionsText:SetText("Custom Filter Presets")

--Search Term EditBox
local keywordBox = CreateFrame("EditBox", "Keywords", FilterFrame, "InputBoxTemplate")
keywordBox:ClearAllPoints()
keywordBox:ClearFocus()
keywordBox:SetAutoFocus(false)
keywordBox:SetCursorPosition(0)
keywordBox:SetSize(70, 30)
keywordBox:SetPoint("CENTER", CAFilterText, "CENTER", -25, -45)
keywordBox:SetScript("OnEnterPressed", function(self)

 local nwKeywordText = keywordBox:GetText()

 keywordBox:ClearFocus()
 keywordBox:AddHistoryLine(nwKeywordText)
 keywordBox:SetText("")
 table.insert(CAKeywordList, nwKeywordText)
 SetKeywordText()

end)

keywordBox.EnterButton = CreateFrame("Button", "KeywordEnter", keywordBox, "UIPanelButtonTemplate")
keywordBox.EnterButton:SetSize(55, 18)
keywordBox.EnterButton:SetNormalFontObject("GameFontWhite")
keywordBox.EnterButton:SetText("Enter")
keywordBox.EnterButton:SetPoint("CENTER", keywordBox, "CENTER", 65, 0)
keywordBox.EnterButton:SetScript("OnClick", keywordBox:GetScript("OnEnterPressed"))

--Filter Keywords Frame
keywordFrame:SetSize(130,75)
keywordFrame:SetPoint("TOPRIGHT",FilterFrame, "TOPRIGHT", -10, -75)
keywordFrame:SetBackdrop( {
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = false, edgeSize = 10,
	insets = {left = 2.5, right = 2.5, top = 2.5, bottom = 2.5}});
keywordFrame:SetBackdropColor(.1, .1, .1, 1)
keywordFrame:SetBackdropBorderColor(1, 1, 1)
keywordFrame.Text = keywordFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
keywordFrame.Text:SetPoint("CENTER", keywordFrame, "CENTER", 0, 0)
keywordFrame.Text:SetWidth(110)
keywordFrame.Text:SetHeight(60)

--Key Word full clear button
keywordFrame.ClearButton = CreateFrame("Button", "KeywordClear", keywordFrame, "UIPanelButtonTemplate");
keywordFrame.ClearButton:SetSize(keywordFrame:GetWidth(), 15);
keywordFrame.ClearButton:SetText("Clear Filter");
keywordFrame.ClearButton:SetPoint("CENTER", keywordFrame, "CENTER", 0, -45);
keywordFrame.ClearButton:SetScript("OnClick", function()
      ClearKeywordText()
end)

--Restrictive Button Checkbox
CARestrictiveBox:SetPoint("CENTER", keywordFrame.ClearButton, "CENTER", -55, -21)
CARestrictiveBox:SetSize(25, 25)
getglobal(CARestrictiveBox:GetName() .. 'Text'):SetFontObject("GameFontNormalSmall")
getglobal(CARestrictiveBox:GetName() .. 'Text'):SetText(" Restrictive Search");
getglobal(CARestrictiveBox:GetName() .. 'Text'):SetTextColor(1, 1, 0)
CARestrictiveBox.tooltip = "Check to enable Restrictive Search. \nRestrictive Search will scan the chat log for the filter words as stand alones, as opposed to \"ST\" appearing in \"street\" for example.";
CARestrictiveBox:SetScript("OnClick",
  function(self)
			local checker = CARestrictiveBox:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
        CARestrictiveBoxBool = true
			else
				PlaySound(857) -- Check Unclick Sound
        CARestrictiveBoxBool = false
			end
	end);

--Keyword delete select EditBox
keywordSelectFrame:ClearAllPoints()
keywordSelectFrame:ClearFocus()
keywordSelectFrame:SetAutoFocus(false)
keywordSelectFrame:SetCursorPosition(0)
keywordSelectFrame:SetSize(115, 45)
keywordSelectFrame:EnableMouse(false)
keywordSelectFrame:SetMultiLine(true)
keywordSelectFrame:SetPoint("CENTER", FilterFrame, "CENTER", -3, -10)

--keyword delete select arrows
CAKeywordArrows:SetPoint("TOPLEFT", keywordSelectFrame, "TOPRIGHT", 4, -10)
CAKeywordArrows:SetPoint("BOTTOMLEFT", keywordSelectFrame, "BOTTOMRIGHT", 4, 5)
CAKeywordArrows:SetMinMaxValues(0, 200)
CAKeywordArrows:SetValueStep(0)
CAKeywordArrows.scrollStep = 1
CAKeywordArrows:SetThumbTexture(nil)
CAKeywordArrows:SetWidth(10)
CAKeywordArrows:SetScript("OnValueChanged",
    function (self, value)
      if(value == table.getn(CAKeywordList) + 1) then
        CAKeywordArrows:SetValue(1)
      else
        if(value == 0) then
          CAKeywordArrows:SetValue(table.getn(CAKeywordList))
        end
      end
        if(table.getn(CAKeywordList) ~= 0) then
          keywordSelectFrame:SetText(CAKeywordList[CAKeywordArrows:GetValue()])
        end
    end)
local scrolltexture = CAKeywordArrows:CreateTexture(nil, "BACKGROUND")
scrolltexture:SetAllPoints(CAKeywordArrows)
scrolltexture:SetColorTexture(0, 0, 0, 0.4)
CAKeywordArrows.background = scrolltexture

--keyword delete select button
keywordFrame.ClearSelectButton = CreateFrame("Button", "KeywordClear", keywordFrame, "UIPanelButtonTemplate");
keywordFrame.ClearSelectButton:SetSize(keywordFrame:GetWidth() - 7, 15);
keywordFrame.ClearSelectButton:SetText("Delete Selected");
keywordFrame.ClearSelectButton:SetPoint("CENTER", keywordSelectFrame, "CENTER", -3, -20);
keywordFrame.ClearSelectButton:SetScript("OnClick", function()
  table.remove(CAKeywordList,CAKeywordArrows:GetValue())
  CAKeywordArrows:SetMinMaxValues(0, table.getn(CAKeywordList) + 1)
  CAKeywordArrows:SetValue(0)
  keywordSelectFrame:SetText("")
  SetKeywordText()
end)

--save preset text
local CASavePresetText = FilterFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
CASavePresetText:SetPoint("CENTER", filterDropdown, "CENTER", 5, -25)
CASavePresetText:SetTextColor(1, 1, 0, 1) -- default color
CASavePresetText:SetText("Custom Preset Name")

--save preset editbox
keywordPresetNameBox:ClearAllPoints()
keywordPresetNameBox:ClearFocus()
keywordPresetNameBox:SetAutoFocus(false)
keywordPresetNameBox:SetCursorPosition(0)
keywordPresetNameBox:SetSize(115, 45)
keywordPresetNameBox:EnableMouse(true)
keywordPresetNameBox:SetMultiLine(false)
keywordPresetNameBox:SetPoint("CENTER", filterDropdown, "CENTER", 5, -45)
keywordPresetNameBox:SetScript("OnEnterPressed", function(self)
  --CAFilterPresets - global table
  --CAKeywordList - current table

  if(table.getn(CAKeywordList) ~= 0) then
    nwFilterList = {};
    CAFilterExists = false;

    for i=1, table.getn(CAFilterPresets) do
      if(CAFilterPresets[i].name == keywordPresetNameBox:GetText()) then
        CAFilterExists = true
      end
    end

    if(CAFilterExists == false) then
      nwFilterList.filterwords = {};
      for i=1, table.getn(CAKeywordList) do
        table.insert(nwFilterList.filterwords, CAKeywordList[i])
      end
      nwFilterList.name = keywordPresetNameBox:GetText();
      table.insert(CAFilterPresets, nwFilterList)
      UIDropDownMenu_SetText(filterDropdown, "Preset: " .. nwFilterList.name)
      keywordPresetNameBox:ClearFocus()
    else
      StaticPopupDialogs["FILTER_LIST_NAME_EXISTS"] = {
        text = "There is already a preset with the name " .. keywordPresetNameBox:GetText(),
        button1 = "Ok",
        timeout = 0,
        whileDead = true,
        hideOnEscape = true,
        preferredIndex = 3,
      }
      StaticPopup_Show ("FILTER_LIST_NAME_EXISTS")
      keywordPresetNameBox:ClearFocus()
    end
  else
    StaticPopupDialogs["FILTER_LIST_EMPTY"] = {
      text = "The filter box is empty, please add search terms before saving",
      button1 = "Ok",
      timeout = 0,
      whileDead = true,
      hideOnEscape = true,
      preferredIndex = 3,
    }
    StaticPopup_Show ("FILTER_LIST_EMPTY")
    keywordPresetNameBox:ClearFocus()
  end
  keywordPresetNameBox:SetText("")
end)

--Add in manual button for naming preset
keywordPresetNameBox.AddPresetButton = CreateFrame("Button", "CreatePresetButton", keywordFrame, "UIPanelButtonTemplate");
keywordPresetNameBox.AddPresetButton:SetSize(keywordFrame:GetWidth() - 7, 15);
keywordPresetNameBox.AddPresetButton:SetText("Save Preset");
keywordPresetNameBox.AddPresetButton:SetPoint("CENTER", keywordPresetNameBox, "CENTER", -3, -20);
keywordPresetNameBox.AddPresetButton:SetScript("OnClick",keywordPresetNameBox:GetScript("OnEnterPressed"))

--Button for deleting presets
CAdeletePresetButton:SetSize(keywordFrame:GetWidth() - 7, 15);
CAdeletePresetButton:SetText("Delete Preset");
CAdeletePresetButton:SetPoint("CENTER",keywordPresetNameBox, "CENTER", -3, -40);
CAdeletePresetButton:SetScript("OnClick", function(self)
  local currPresetName = strsub(UIDropDownMenu_GetText(filterDropdown), 9)
  for i=1, table.getn(CAFilterPresets) do
    if(CAFilterPresets[i].name == currPresetName) then
      table.remove(CAFilterPresets, i)
      ClearKeywordText();
      UIDropDownMenu_SetText(filterDropdown, "Preset: None")
      SetFilterDropdownItems();
      break;
    end
  end
end)
--ADDIN IN SLASH COMMANDS
local function ChatAwareCommands(msg, editbox)
    if msg == '' then
      if(CAframe:IsShown() == false) then
        CAframe:Show()
        CAscrollframe:SetVerticalScroll(CAscrollbar.scrollStep)
        AlignTextItems()
      else
        CAframe:Hide()
      end
    end
    if msg == 'help' then
      print("|cffff0000Chat Assistant Commands:|r")
      print("|cffffff00 -'/chatassist - or - /chatassistant' - Show/Hide the 'Chat Assistant' window |r")
      print("|cffffff00 -'/chatassist reset' - Reset the 'Chat Assistant' window to its original size|r")
      print("|cffffff00 -'/chatassist center' - Center the 'Chat Assistant' window on the screen|r")
    end
    if msg == 'center' then
        CAframe:ClearAllPoints()
        CAframe:SetPoint("CENTER")
        AlignTextItems()
    end
    if msg == 'reset' then
        CAframe:SetSize(460,380)
        AlignTextItems()
    end
end
SLASH_CHATASSIST1 = '/chatassist'
SLASH_CHATASSIST2 = '/chatassistant'
SlashCmdList["CHATASSIST"] = ChatAwareCommands

--UPDATE AND EVENETS
local function OnChatUpdates(text, event, message, sender)

  if(event == "PLAYER_ENTERING_WORLD")then
    SetKeywordText() -- set the keywords in the box when the player enters the world
    CARestrictiveBox:SetChecked(CARestrictiveBoxBool);
  end

  if(event == "CHAT_MSG_CHANNEL") then
   --loop through the keyword search terms, see if what we are looking for exists.
   for i = 1,table.getn(CAKeywordList),1 do
     local _, spaceCount = string.gsub(CAKeywordList[i], " ", "")
     --get number of spaces in the phrase^
     if(spaceCount == 0) then
       --START LOOKING FOR 0 SPACE'D KEYWORDS
       local wordCheck = CAKeywordList[i];

       if(strfind(CAKeywordList[i], "+")) then
         wordCheck = strsub(CAKeywordList[i], 0, strfind(CAKeywordList[i], "+") - 1) .. "%" .. strsub(CAKeywordList[i], strfind(CAKeywordList[i], "+"))
       end

       --if(strfind(CAKeywordList[i], "/")) then
         --handle the case for individual words have a slash (i.e. healer/tank)
         --wordCheck = strsub(CAKeywordList[i], 0, strfind(CAKeywordList[i], "/") - 1).. " " .. strsub(CAKeywordList[i], strfind(CAKeywordList[i], "/") + 1)
       --end
       --check single nospace
       if(strfind(strlower(message), strlower(wordCheck))) then
         if(CARestrictiveBoxBool == true) then
           local firstChar, secondChar = strfind(strlower(message), strlower(wordCheck))
           if( ((strsub(message, firstChar - 1, firstChar - 1) == "") or (strsub(message, firstChar - 1, firstChar - 1) == " ")) and ((strsub(message, secondChar + 1, secondChar + 1) == "") or ((strsub(message, secondChar + 1, secondChar + 1) == " ")))) then
             playerName = "|Hplayer:"..sender.."|h["..sender.."]|h"
             --get the current hour/minute
             local msgTime = date("%H:%M");
             message = strjoin("","[" .. msgTime .. "]" .. " - " .. playerName .. ": ", message)
             content:AddMessage(tostring(message))
             break;
           end
         else
           playerName = "|Hplayer:"..sender.."|h["..sender.."]|h"
           local msgTime = date("%H:%M");
           message = strjoin("","[" .. msgTime .. "]" .. " - " .. playerName .. ": ", message)
           content:AddMessage(tostring(message))
           break;
         end
       end

       --END LOOKING FOR 0 SPACE'D KEYWORDS
     else
       local stringBreaker = CAKeywordList[i] .. " "
       local indivWords = {}
       local matchingWords = true;
       --break up the string word by word, seperated by spaces
       for j = 1, spaceCount + 1, 1 do
        local singWord = strsub(stringBreaker, 0, strfind(stringBreaker, " ") - 1);
        table.insert(indivWords, singWord);
        stringBreaker = strsub(stringBreaker, strfind(stringBreaker, " ") + 1)
       end
       --loop through each individual word, if it finds a word in the phrase that isnt in the message, set matchingWords to false
       for k = 1, table.getn(indivWords), 1 do
         local wordCheck = indivWords[k];
         if(strfind(indivWords[k], "+")) then
           wordCheck = strsub(indivWords[k], 0, strfind(indivWords[k], "+") - 1) .. "%" .. strsub(indivWords[k], strfind(indivWords[k], "+"))
         end

         --treat "/" as a space
         --if(strfind(indivWords[i], "/")) then
           --wordCheck = strsub(indivWords[i], 0, strfind(indivWords[i], "/") - 1).. " " .. strsub(indivWords[i], strfind(indivWords[i], "/") + 1)
         --end

         if(strfind(strlower(message), strlower(wordCheck)) == nil) then
             matchingWords = false
         end

        local firstChar, secondChar = strfind(strlower(message), strlower(wordCheck))
        if(firstChar == nil or secondChar == nil) then
          matchingWords = false;
        elseif(CARestrictiveBoxBool == true)then
          if((strsub(message, firstChar - 1, firstChar - 1) == "") or (strsub(message, firstChar - 1, firstChar - 1) == " ") or (strsub(message, firstChar - 1, firstChar - 1) == nil)) then
            if((strsub(message, secondChar + 1, secondChar + 1) == "") or (strsub(message, secondChar + 1, secondChar + 1) == " ") or (strsub(message, secondChar + 1, secondChar + 1) == nil)) then
            else
              matchingWords = false
            end
          else
            matchingWords = false
          end
        end
      end
       --if the forloop closes and matchingWords is still true
       if(matchingWords == true) then
         playerName = "|Hplayer:"..sender.."|h["..sender.."]|h"
         local msgTime = date("%H:%M");
         message = strjoin("","[" .. msgTime .. "]" .. " - " .. playerName .. ": ", message)
         content:AddMessage(tostring(message))
         break;
       end
     end
   end
  end
end

CAframe:RegisterEvent("PLAYER_ENTERING_WORLD")
CAframe:RegisterEvent("CHAT_MSG_CHANNEL")
CAframe:SetScript("OnEvent", OnChatUpdates)
